//
//  Shaders.metal
//  RenderingWithMetal
//
//  Created by Harold Serrano on 5/7/22.
//

// File for Metal kernel and shader functions

#include <metal_stdlib>
#include <simd/simd.h>

// Including header shared between this Metal shader code and Swift/C code executing Metal API commands
#import "ShaderTypes.h"

using namespace metal;

typedef struct
{
    float3 position [[attribute(0)]];
    
} Vertex;

typedef struct
{
    float4 position [[position]];
    
} VertexOut;

vertex VertexOut vertexShader(Vertex in [[stage_in]],
                               constant Uniforms & uniforms [[ buffer(1) ]]){
    VertexOut out;

    float4 position = float4(in.position, 1.0);
    out.position = uniforms.projectionMatrix * uniforms.modelViewMatrix * position;

    return out;
}

fragment float4 fragmentShader(VertexOut in [[stage_in]])
{
    half4 colorSample=half4(1.0,0.0,0.0,1.0);
    return float4(colorSample);
}
